<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("./functions.php");
authenticate();
html_start("SpamAssassin Rule Description Update");

?>
<FORM METHOD="POST" ACTION=<?=$_SERVER['PHP_SELF']?>>
<INPUT TYPE="HIDDEN" NAME="run" VALUE="true">
<TABLE CLASS="BOXTABLE" WIDTH="100%">
 <TR>
  <TD>
   This utility is used to update the SQL database with up-to-date descriptions of the SpamAssassin rules which are displayed on the Message Detail screen.<BR>
   <BR>
   This utility should generally be run after a SpamAssassin update, however it is safe to run at any time as it only replaces the existing values and inserts only new values in the table (therefore preserving descriptions from potentially deprecated or removed rules).<BR>
  </TD>
 </TR>
 <TR>
  <TD ALIGN="CENTER"><BR><INPUT TYPE="SUBMIT" VALUE="Run Now"><BR><BR></TD>
 </TR>
<?

if($_POST['run']) {
 echo "<TR><TD ALIGN=\"CENTER\"><TABLE CLASS=\"mail\"><THEAD><TH>Rule</TH><TH>Description</TH></THEAD>\n";
 $fh = popen("ls ".SA_RULES_DIR."*.cf | xargs grep -h '^describe'",'r');
 while (!feof($fh)) {
  $line = rtrim(fgets($fh,4096));
  debug("line: ".$line."\n");
  preg_match("/^describe (\S*)(\t|  )(.+)$/",$line,$regs);
  if ($regs[1] && $regs[3]) {
   $regs[1] = mysql_escape_string(ltrim(rtrim($regs[1])));
   $regs[3] = mysql_escape_string(ltrim(rtrim($regs[3])));
   echo "<TR><TD>".$regs[1]."</TD><TD>".$regs[3]."</TD></TR>\n";
   dbquery("REPLACE INTO sa_rules VALUES ('$regs[1]','$regs[3]')");
  } else {
   preg_match("/^describe (\S*) (.+)$/",$line,$regs);
   if ($regs[1] && $regs[2]) {
    $regs[1] = mysql_escape_string(ltrim(rtrim($regs[1])));
    $regs[2] = mysql_escape_string(ltrim(rtrim($regs[2])));
    echo "<TR><TD>".$regs[1]."</TD><TD>".$regs[2]."</TD></TR>\n";
    dbquery("REPLACE INTO sa_rules VALUES ('$regs[1]','$regs[2]')");
   } else {
    debug("$line - did not match regex, not inserting into database");
   }
  }
 }
 pclose($fh);
 echo "</TABLE><BR></TD></TR>\n";
}
?>
</TABLE>
<?
html_end();
?>
