<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("functions.php");
authenticate();
$refresh = html_start("Recent Messages",STATUS_REFRESH,false);

if ($_GET['show'] == "virus") {
 $where_and = "AND virusinfected>0\n";
}

if ($_GET['show'] == "spam") {
 $where_and = "AND isspam>0\n";
}

if ($_GET['show'] == "blocked_file") {
 $where_and = "AND nameinfected>0\n";
}

if ($_GET['show'] == "other") {
 $where_and = "AND otherinfected>0\n";
}

$result = mysql_query("
 SELECT 
  DATE_FORMAT(timestamp, '%d/%m/%y %H:%i:%s') AS datetime, 
  id AS id,
  from_address,
  to_address,
  subject,
  size as size,
  CASE WHEN isspam>0 THEN 'Y' ELSE 'N' END AS isspam,
  CASE WHEN ishighspam>0 THEN 'Y' ELSE 'N' END AS ishighspam,
  CASE WHEN isrblspam>0 THEN 'Y' ELSE 'N' END AS isrblspam,
  CASE WHEN spamwhitelisted>0 THEN 'Y' ELSE 'N' END AS iswhitelisted,
  sascore,
  CASE WHEN virusinfected>0 THEN 'Y' ELSE 'N' END AS virusinfected,
  CASE WHEN nameinfected>0 THEN 'Y' ELSE 'N' END AS nameinfected,
  CASE WHEN otherinfected>0 THEN 'Y' ELSE 'N' END AS otherinfected,
  LEFT(hostname,INSTR(hostname,'.')-1) AS host,
  report
 FROM
  maillog
 WHERE
  1=1
 $where_and
 ORDER BY 
  date DESC
 LIMIT ".MAX_RESULTS) 
 or die("Error executing query: ".mysql_error());

// Generate the table with headings
$num_fields = mysql_num_fields($result);
echo "<TABLE CLASS=\"mail\" BORDER=0 WIDTH=100% CELLSPACING=2 CELLPADDING=2>\n";
echo " <THEAD>\n";
echo "  <TH COLSPAN=9>Last ".MAX_RESULTS." Messages (Refresh = ".$refresh." seconds)</TH>\n";
echo " </THEAD>\n";
echo " <THEAD>\n";
echo "  <TH>Date/Time</TH>\n";
echo "  <TH>Host</TH>\n";
echo "  <TH>ID</TH>\n";
echo "  <TH>From</TH>\n";
echo "  <TH>To</TH>\n";
echo "  <TH>Subject</TH>\n";
echo "  <TH ALIGN=\"CENTER\">Size</TH>\n";
echo "  <TH ALIGN=\"CENTER\">SA Score</TH>\n";
echo "  <TH>Status</TH>\n";
echo " </THEAD>\n";


while($row = mysql_fetch_object($result)) {
 $status_array = array();

 if ($row->isspam == 'Y') {
  array_push($status_array, "Spam");
 } 
 
 if ($row->iswhitelisted == 'Y') {
  array_push($status_array, "Whitelisted");
 }

 if ($row->virusinfected == 'Y') {
  // Get the virus name
  if(preg_match(VIRUS_REGEX,$row->report,$virus)) {
   array_push($status_array, "Virus ($virus[2])");
  } else {
   array_push($status_array, "Virus");
  }
 }

 if ($row->nameinfected == 'Y') {
  array_push($status_array, "Blocked attachment");
 }
 
 if ($row->otherinfected == 'Y') {
  array_push($status_array, "Other infection");
 }

 if (count($status_array) == 0) {
  array_push($status_array, "Clean");
 }

 $status = join($status_array,", ");

 # Row colorings
 if ($row->virusinfected == 'Y' || $row->nameinfected == "Y" || $row->otherinfected == "Y") {
  echo " <TR CLASS=\"infected\">\n";
 } elseif ($row->isspam == 'Y') {
  echo " <TR CLASS=\"spam\">\n";
 } elseif ($row->iswhitelisted == 'Y') {
  echo " <TR CLASS=\"whitelisted\">\n";
 } else {
  echo " <TR>";
 }

 if (FROMTO_MAXLEN>0) {
  $row->from_address = trim_output(htmlentities($row->from_address), FROMTO_MAXLEN);
  $row->to_address = trim_output(htmlentities($row->to_address), FROMTO_MAXLEN);
 } else {
  $row->to_address = str_replace(",", "<BR />", htmlentities($row->to_address));
 }

 if (SUBJECT_MAXLEN>0) {
   $row->subject = trim_output($row->subject, SUBJECT_MAXLEN);
 }

 echo "  <TD>" 			. $row->datetime		. "</TD>\n";
 echo "  <TD>"			. $row->host			. "</TD>\n";
 echo "  <TD><A HREF=\"detail.php?id=$row->id\">". $row->id. "</A></TD>\n";
 echo "  <TD>" 	. 	$row->from_address		 . "</TD>\n";
 echo "  <TD>"  . 	$row->to_address		 . "</TD>\n";
 echo "  <TD>" 	. 	$row->subject 			. "</TD>\n";
 echo "  <TD ALIGN=\"RIGHT\">" 	. format_mail_size($row->size)	. "</TD>\n";
 echo "  <TD ALIGN=\"RIGHT\">" 	. $row->sascore			. "</TD>\n";
 echo "  <TD>" 			. $status			. "</TD>\n";
 echo " </TR>\n";
}
echo "<TABLE>\n";

html_end();
?>
